#version 430 core
layout (location = 0) in vec3 aPos;

out vec4 fPosition;

uniform mat4 model;
uniform mat4 lightVpMatrix;

void main()
{
	fPosition = model * vec4(aPos, 1.0);
    gl_Position = lightVpMatrix * fPosition;
}