#version 430 core
out vec4 FragColor;

in vec2 TexCoords;

uniform sampler2D texture_diffuse1;

void main()
{
    FragColor = texture(texture_diffuse1, TexCoords);
}




//
//
//
//
//
//
//
//
//#version 430 core
//out vec4 FragColor;
//
//in vec3 fNormal;  
//in vec3 fPosition;
//in vec2 fTextCoords;
//in vec4 fPositionLightSpace;
//
//uniform vec3 lampLightPosition;
//uniform vec3 moonLightDirection;
//uniform vec3 moonLightPosition; //lschen
//
//
////uniform sampler2D fragTexture;
//uniform sampler2D texture_diffuse;
//uniform sampler2D moonShadowMap;
//uniform samplerCube lampShadowMap;
//
//uniform vec3 viewPosition;
//uniform float farPlane;
//uniform vec3 specularObject;
//uniform float shininessObject;
//
//vec3 gridSamplingDisk[20] = vec3[]
//(
//   vec3(1, 1,  1), vec3( 1, -1,  1), vec3(-1, -1,  1), vec3(-1, 1,  1), 
//   vec3(1, 1, -1), vec3( 1, -1, -1), vec3(-1, -1, -1), vec3(-1, 1, -1),
//   vec3(1, 1,  0), vec3( 1, -1,  0), vec3(-1, -1,  0), vec3(-1, 1,  0),
//   vec3(1, 0,  1), vec3(-1,  0,  1), vec3( 1,  0, -1), vec3(-1, 0, -1),
//   vec3(0, 1,  1), vec3( 0, -1,  1), vec3( 0, -1, -1), vec3( 0, 1, -1)
//);
//
//
//
////vec3 calculateMoonLight(vec3 fNormal, vec3 fPosition, vec3 moonLightDirection, vec3 viewPosition, vec3 specularObject, float shininessObject);
////vec3 calculateLampLight(vec3 fNormal, vec3 fPosition, vec3 lightPosition, vec3 viewPosition, vec3 specularObject, float shininessObject);
////float calculateMoonShadow(vec4 fPositionLightSpace);
////float calculateLampShadow(vec3 fPosition);
//vec3 calculateMoonLight();
//vec3 calculateLampLight();
//float calculateMoonShadow();
//float calculateLampShadow();
//
//void main()
//{
//	//phong lighting model
//	//Ip = ka * ia + kd * (vec(surface to light source) * vec(surface normal)) * id + ks * (vec(reflection) * vec(dir to viewer))^shininess * is
//	//i... light intensities, k... ambient, diffuse, specular components
//	//all vectors normalized
//	//vec(reflection) = 2 * (vec(surface to light source) * vec(surface normal)) * vec(surface normal) - vec(surface to light source)
//
//	//if((texture(fragTexture, fTextCoords)).a < 0.6) //discard semi-transparent parts (for tree leaves)
//	//if((texture(fragTexture, fTextCoords)).a < 0.6)
//	//discard;
//
////	// ambient part
////    float ambient = 0.15f; //ka
////	//float ambient = 1.0f;
////    vec3 ambientPart = ambient * texture(fragTexture, fTextCoords).rgb;
////  	
////    // diffuse part
////	float diff = 0.8f; //kd
////    vec3 norm = normalize(fNormal); //vec(surface normal)
////    vec3 lightDirection = normalize(lightPosition - fPosition); //vec(surface to light source)
////    float diffuse = max(dot(norm, lightDirection),0.0);	//diffuse can't be negative, even with 90degrees
////    vec3 diffusePart = diff * diffuse * texture(fragTexture, fTextCoords).rgb;
////    
////    // specular part
////    vec3 specular = vec3(0.3f, 0.3f, 0.3f); //id
////    vec3 viewDir = normalize(viewPosition - fPosition); //vec(dir to viewer)
////    vec3 reflectDir = reflect(-lightDirection, norm);  //vec(reflection)
////    float spec = pow(max(dot(viewDir, reflectDir), 0.0), shininessObject);
////    vec3 specularPart = specular * spec * specularObject;
////    
////	float lightDistance = length(lightPosition - fPosition); //(distance surface to light)
////
////	//attenuation... object is less lit if farther away from light
////	//att = 1 / (constant + linear factor * vec(distance surface to light) + quadratic factor * (distance surface to light)^2)
////	float attenuation = 1.0 / (1.0 + 0.027 * lightDistance + 0.0028 * pow(lightDistance,2));
////	
////	vec3 result = ambientPart + attenuation * (diffusePart + specularPart);
//
//	//vec3 result = calculateLampLight(fNormal, fPosition, lampLightPosition, viewPosition, specularObject, shininessObject);
//	vec3 result = calculateLampLight();
//	//vec3 result = calculateMoonLight(fNormal, fPosition, moonLightDirection, viewPosition, specularObject, shininessObject);
//	//vec3 result = calculateMoonLight();
//	//result += calculateMoonLight(fNormal, fPosition, moonLightDirection, viewPosition, specularObject, shininessObject);
//	result += calculateMoonLight();
//	//if((texture(fragTexture, fTextCoords)).a < 0.6)
//	if((texture(texture_diffuse, fTextCoords)).a < 0.6)
//	discard;
//    FragColor = vec4(result, 1.0);
//	
//
//    //FragColor = vec4(texture(fragTexture, fTextCoords).a, 0.0f, 0.0f, 1.0f); //debug alpha channel
//	   
//} 
//
//vec3 calculateLampLight()
//{
//	// ambient part
//    float ambient = 0.15f; //ka
//	//float ambient = 1.0f;
//    //vec3 ambientPart = ambient * texture(fragTexture, fTextCoords).rgb;
//	vec3 ambientPart = ambient * texture(texture_diffuse, fTextCoords).rgb;
//  	
//    // diffuse part
//	float diff = 0.6f; //kd
//    vec3 norm = normalize(fNormal); //vec(surface normal)
//    vec3 lightDirection = normalize(lampLightPosition - fPosition); //vec(surface to light source)
//    float diffuse = max(dot(norm, lightDirection),0.0);	//diffuse can't be negative, even with 90degrees
//    //vec3 diffusePart = diff * diffuse * texture(fragTexture, fTextCoords).rgb;
//	vec3 diffusePart = diff * diffuse * texture(texture_diffuse, fTextCoords).rgb;
//    
//    // specular part
//    vec3 specular = vec3(0.3f, 0.3f, 0.3f); //id
//    vec3 viewDir = normalize(viewPosition - fPosition); //vec(dir to viewer)
//    vec3 reflectDir = reflect(-lightDirection, norm);  //vec(reflection)
//    float spec = pow(max(dot(viewDir, reflectDir), 0.0), shininessObject);
//    vec3 specularPart = specular * spec * specularObject;
//    
//	float lightDistance = length(lampLightPosition - fPosition); //(distance surface to light)
//
//	//attenuation... object is less lit if farther away from light
//	//att = 1 / (constant + linear factor * vec(distance surface to light) + quadratic factor * (distance surface to light)^2)
//	float attenuation = 1.0 / (1.0 + 0.027 * lightDistance + 0.0028 * pow(lightDistance,2));
//
//	 float shadowValue = calculateLampShadow();
//
//
//	// return (ambientPart + (1.0 - shadowValue) * (diffusePart + specularPart));
//	 return (ambientPart + (1.0 - shadowValue) * attenuation * (diffusePart + specularPart));
//
//	//return (ambientPart + attenuation * (diffusePart + specularPart));
//
//}
//
//vec3 calculateMoonLight()
//{
//
//	// ambient part
//    float ambient = 0.05f; //ka
//	//float ambient = 1.0f; //ka, debug for shadows
//	//vec3 ambientPart = ambient * texture(fragTexture, fTextCoords).rgb;
//	vec3 ambientPart = ambient * texture(texture_diffuse, fTextCoords).rgb;
//	
//	// diffuse part
//	float diff = 0.05f; //kd
//	vec3 norm = normalize(fNormal); //vec(surface normal)
//    //vec3 lightDirection = normalize(lightPosition - fPosition); //vec(surface to light source)
//	vec3 lightDirection = normalize(-moonLightDirection);
//    float diffuse = max(dot(norm, lightDirection),0.0);	//diffuse can't be negative, even with 90degrees
//    //vec3 diffusePart = diff * diffuse * texture(fragTexture, fTextCoords).rgb;
//	vec3 diffusePart = diff * diffuse * texture(texture_diffuse, fTextCoords).rgb;
//
//	 // specular part
//	vec3 specular = vec3(0.2f, 0.2f, 0.2f); //id
//    vec3 viewDir = normalize(viewPosition - fPosition); //vec(dir to viewer)
//    vec3 reflectDir = reflect(-lightDirection, norm);  //vec(reflection)
//    float spec = pow(max(dot(viewDir, reflectDir), 0.0), shininessObject);
//    vec3 specularPart = specular * spec * specularObject;   
//    
//	float shadowValue = calculateMoonShadow();
//
//	return (ambientPart + (1.0 - shadowValue) * (diffusePart + specularPart));	
//
//    //return (ambientPart + diffusePart + specularPart);
//}
//
//
//float calculateMoonShadow()
//{
//
//	//vec3 fragToLight = fPosition.xyz - moonLightPosition;
//	vec3 projCoords = fPositionLightSpace.xyz;
//	//vec3 projCoords = fPosition.xyz;
//	 projCoords = projCoords * 0.5 + 0.5;
//    // use the fragment to light vector to sample from the depth map    
//    //float closestDepth = texture(moonShadowMap, fragToLight).r;
//    // it is currently in linear range between [0,1], let's re-transform it back to original depth value
//    // closestDepth *= far_plane;
//    // now get current linear depth as the length between the fragment and light position
//   // float currentDepth = length(fragToLight);
//	 //float closestDepth = texture(moonShadowMap, fragToLight.xy).r;
//	 float closestDepth = texture(moonShadowMap, projCoords.xy).r;
//	  //float currentDepth = fPosition.z;
//	  float currentDepth = projCoords.z;
//	 //float closestDepth = texture(moonShadowMap, fPosition.xy).r;
//	 //closestDepth *= 40.0f;
//	 float bias = 0.005;
//	 //float shadow = currentDepth -  bias > closestDepth ? 1.0 : 0.0;
//
//	//_______________________________________________________________________________
//
////	// perform perspective divide
////    vec3 projCoords = fPositionLightSpace.xyz / fPositionLightSpace.w;
////    // transform to [0,1] range
////    projCoords = projCoords * 0.5 + 0.5;
////    // get closest depth value from light's perspective (using [0,1] range fragPosLight as coords)
////    float closestDepth = texture(moonShadowMap, projCoords.xy).r; 
////    // get depth of current fragment from light's perspective
////    float currentDepth = projCoords.z;
////    // check whether current frag pos is in shadow
////	float bias = 0.005;
////    //float shadow = currentDepth > closestDepth  ? 1.0 : 0.0;
////	//vec3 lightDirection = normalize(-moonLightDirection);
////	//float bias = max(0.05 * (1.0 - dot(fNormal, lightDirection)), 0.005);
////	//float shadow = currentDepth - bias > closestDepth  ? 1.0 : 0.0; 
////
//	//PCF
//	float shadow = 0.0;
//    vec2 texelSize = 1.0 / textureSize(moonShadowMap, 0);
//    for(int x = -1; x <= 1; ++x)
//    {
//        for(int y = -1; y <= 1; ++y)
//        {
//            float pcfDepth = texture(moonShadowMap, projCoords.xy + vec2(x, y) * texelSize).r; 
//            shadow += currentDepth - bias > pcfDepth  ? 1.0 : 0.0;        
//        }    
//    }
//    shadow /= 9.0;
//
//	if(projCoords.z > 1.0)
//        shadow = 0.0;
////	
//    return shadow;
//}
//
//
//float calculateLampShadow()
//{
//    // get vector between fragment position and light position
//    vec3 lightDirection = fPosition - lampLightPosition; //fragment to light
//    // ise the fragment to light vector to sample from the depth map    
//    //float closestDepth = texture(lampShadowMap, lightDirection).r;
//    // it is currently in linear range between [0,1], let's re-transform it back to original depth value
//    //closestDepth *= farPlane;
//    // now get current linear depth as the length between the fragment and light position
//    float currentDepth = length(lightDirection);
//    // test for shadows
//    float bias = 0.1; // we use a much larger bias since depth is now in [near_plane, far_plane] range
//    //float shadow = currentDepth -  bias > closestDepth ? 1.0 : 0.0;        
//    // display closestDepth as debug (to visualize depth cubemap)
//    // FragColor = vec4(vec3(closestDepth / far_plane), 1.0);  
//	
//	//float bias = max(0.05 * (1.0 - dot(fNormal, lightDirection)), 0.005);
//
//	//pcf verbessert
//	 float shadow = 0.0;
//    //float bias = 0.15;
//    int samples = 20;
//    float viewDistance = length(viewPosition - fPosition);
//    float diskRadius = (1.0 + (viewDistance / farPlane)) / 25.0;
//    for(int i = 0; i < samples; ++i)
//    {
//        float closestDepth = texture(lampShadowMap, lightDirection + gridSamplingDisk[i] * diskRadius).r;
//        closestDepth *= farPlane;   // undo mapping [0;1]
//        if(currentDepth - bias > closestDepth)
//            shadow += 1.0;
//    }
//    shadow /= float(samples);
//
//	//pcf normal
////	float shadow  = 0.0;
////	//float bias    = 0.05; 
////	float samples = 4.0;
////	float offset  = 0.1;
////	for(float x = -offset; x < offset; x += offset / (samples * 0.5))
////	{
////		for(float y = -offset; y < offset; y += offset / (samples * 0.5))
////		{
////			for(float z = -offset; z < offset; z += offset / (samples * 0.5))
////			{
////				float closestDepth = texture(lampShadowMap, lightDirection + vec3(x, y, z)).r; 
////				closestDepth *= farPlane;   // Undo mapping [0;1]
////				if(currentDepth - bias > closestDepth)
////					shadow += 1.0;
////			}
////		}
////	}
////	shadow /= (samples * samples * samples);
//
//
//        
//    return shadow;
//}