#version 430 core
layout (location = 0) in vec3 aPos;
layout (location = 2) in vec2 aTexCoords;
layout (location = 3) in mat4 aInstanceMatrix;

out vec2 TexCoords;

uniform mat4 projection;
uniform mat4 view;

void main()
{
    TexCoords = aTexCoords;
    gl_Position = projection * view * aInstanceMatrix * vec4(aPos, 1.0f); 
}






//#version 430 core
//layout (location = 0) in vec3 positions;
//layout (location = 1) in vec3 normals;
//layout (location = 2) in vec2 vTextCoords;
//layout (location = 3) in mat4 aInstanceMatrix;
//
//out vec3 fPosition;
//out vec3 fNormal;
//out vec2 fTextCoords;
//out vec4 fPositionLightSpace;
//
////uniform mat4 model;
//uniform mat4 vp; //projection * view
//uniform mat4 lightVpMatrix; //light's vp matrix, transform to light space
//
//
//void main()
//{
//	//fPosition = vec3(model * vec4(positions, 1.0)); //transform vertex position to world space, because lighting calculations in fragment shader in world space
//    //fNormal = mat3(transpose(inverse(model))) * normals;
//
//
//
//	fPosition = vec3(aInstanceMatrix * vec4(positions, 1.0)); //transform vertex position to world space, because lighting calculations in fragment shader in world space
//    fNormal = mat3(transpose(inverse(aInstanceMatrix))) * normals;
//
//
//	fPositionLightSpace = lightVpMatrix * vec4(fPosition, 1.0);
//
//	fTextCoords = vTextCoords;
//	gl_Position = vp * vec4(fPosition, 1.0);    
//	
//}