#version 430 core
//shader for skybox
layout (location = 0) in vec3 position;

out vec3 fTextCoords;

uniform mat4 vp;

void main()
{
    fTextCoords = position;	
	vec4 pos = vp * vec4(position, 1.0);
    gl_Position = pos.xyww; //to make sure z is always 1 (highest depth value), (w/w =1)
}