#version 430 core
//shader for lamp's depth cubemap
layout (location = 0) in vec3 positions;
layout (location = 2) in vec2 vTextCoords;

uniform mat4 model;

out vertexData {
	vec2 textCoords;
} outputData;


void main()
{	
	outputData.textCoords = vTextCoords;
    gl_Position = model * vec4(positions, 1.0);
}