#version 430 core
//shader for moon shadow map
layout (location = 0) in vec3 positions;
layout (location = 2) in vec2 vTextCoords;

out vec2 fTextCoords;

uniform mat4 lightVpMatrix; //light's vp matrix
uniform mat4 model; 

void main()
{
	fTextCoords = vTextCoords;
    gl_Position = lightVpMatrix * model * vec4(positions, 1.0);
}